#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    int t; cin>>t;
    while(t--){
        int n,m,s;
        cin>>n>>m>>s;
        vector<int> sab(s+1);
        for(int i=0;i<s;i++) cin>>sab[i];
        vector<vector<int>> adj(n+1);
        vector<pair<int,int>> u;
        for(int i=0;i<m;i++){
            int a,b; cin>>a>>b;
            adj[a].push_back(b);
            adj[b].push_back(a);
            u.push_back({a,b});
        }
        if(m==n-1)
        {
            bool ok=true;
            for(int i=0;i<s;i++){
                if(adj[sab[i]].size()>1){
                    ok=false;
                    break;
                }
            }
            if(ok){
                cout<<m<<endl;
                for(int i=0;i<u.size();i++){
                    cout<<u[i].first<<" "<<u[i].second<<endl;
                }
            }
            else
                cout<<-1<<endl;
        }
    }
    return 0;
}